// -*- C++ -*-
/*!
 * @file  sound.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#pragma comment(lib,"Winmm.lib")
#include "sound.h"
#include <mmsystem.h>

// Module specification
// <rtc-template block="module_spec">
static const char* sound_spec[] =
  {
    "implementation_id", "sound",
    "type_name",         "sound",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "VenderName",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
sound::sound(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_giveIn("give", m_give),
    m_receiveIn("receive", m_receive)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
sound::~sound()
{
}



RTC::ReturnCode_t sound::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("give", m_giveIn);
  addInPort("receive", m_receiveIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t sound::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t sound::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t sound::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t sound::onActivated(RTC::UniqueId ec_id)
{
		
	
  return RTC::RTC_OK;
}


RTC::ReturnCode_t sound::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t sound::onExecute(RTC::UniqueId ec_id)
{
	
	if (m_receiveIn.isNew()){
		m_receiveIn.read();

		//󂯎M\
		std::cout << "receive readNo.: " << m_receive.data << std::endl;
		//int receivechk=m_receiveIn.isEmpty();

		if (m_receive.data == 1){
			PlaySound("receive.wav", NULL, SND_FILENAME | SND_ASYNC | SND_NOSTOP);

		}
	}
	
	if (m_giveIn.isNew()){
		m_giveIn.read();

		//󂯎M\
		std::cout << "give readNo.: " << m_receive.data << std::endl;
		//int givechk = m_receiveIn.isEmpty();

		if (m_give.data == 1){
			PlaySound("give.wav", NULL, SND_FILENAME | SND_ASYNC | SND_NOSTOP);

		}
	}
	
	return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t sound::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t sound::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t sound::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t sound::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t sound::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void soundInit(RTC::Manager* manager)
  {
    coil::Properties profile(sound_spec);
    manager->registerFactory(profile,
                             RTC::Create<sound>,
                             RTC::Delete<sound>);
  }
  
};


